/*
  ʬҥǡ
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
#include "subcomp.h"

/* private function */

#define ATOM_NO_MAX 111   /* бϰϤϤäȶΤ */
static char* atom_label[] = { "",
             "H" , "He", "Li", "Be", "B" ,  /*   1 ~   5 */
             "C" , "N" , "O" , "F" , "Ne",  /*   6 ~  10 */
             "Na", "Mg", "Al", "Si", "P" ,  /*  11 ~  15 */
             "S" , "Cl", "Ar", "K" , "Ca",  /*  16 ~  20 */
             "Sc", "Ti", "V" , "Cr", "Mn",  /*  21 ~  25 */
             "Fe", "Co", "Ni", "Cu", "Zn",  /*  26 ~  30 */
             "Ga", "Ge", "As", "Se", "Br",  /*  31 ~  35 */
             "Kr", "Rb", "Sr", "Y" , "Zr",  /*  36 ~  40 */
             "Nb", "Mo", "Tc", "Ru", "Rh",  /*  41 ~  45 */
             "Pd", "Ag", "Cd", "In", "Sn",  /*  46 ~  50 */
             "Sb", "Te", "I" , "Xe", "Cs",  /*  51 ~  55 */
             "Ba", "La", "Ce", "Pr", "Nd",  /*  56 ~  60 */
             "Pm", "Sm", "Eu", "Gd", "Tb",  /*  61 ~  65 */
             "Dy", "Ho", "Er", "Tm", "Yb",  /*  66 ~  70 */
             "Lu", "Hf", "Ta", "W" , "Re",  /*  71 ~  75 */
             "Os", "Ir", "Pt", "Au", "Hg",  /*  76 ~  80 */
             "Tl", "Pb", "Bi", "Po", "At",  /*  81 ~  85 */
             "Rn", "Fr", "Ra", "Ac", "Th",  /*  86 ~  90 */
             "Pa", "U" , "Np", "Pu", "Am",  /*  91 ~  95 */
             "Cm", "Bk", "Cf", "Es", "Fm",  /*  96 ~ 100 */
             "Md", "No", "Lr", "Rf", "Db",  /* 101 ~ 105 */
             "Sg", "Bh", "Hs", "Mt", "Ds",  /* 106 ~ 110 */
             "Rg", ""  , ""  , ""  , ""};   /* 111       */

/* CPDMOLΰ賫 */
void clear_CPDMOL(CPDMOL *cpdmol){
  int i;

  if (cpdmol == NULL) return;
  if (cpdmol->name != NULL){
    free(cpdmol->name);
    cpdmol->name = NULL;
  }
  if (cpdmol->definition != NULL){
    free(cpdmol->definition);
    cpdmol->definition = NULL;
  }
  if (cpdmol->atom != NULL){
    for (i = 0; i < cpdmol->atomnum; i++){
      if (cpdmol->atom[i].prop1 != NULL){
        free(cpdmol->atom[i].prop1);
      }
      if (cpdmol->atom[i].prop2 != NULL){
        free(cpdmol->atom[i].prop2);
      }
      if (cpdmol->atom[i].bond != NULL){
        free(cpdmol->atom[i].bond);
      }
    }
    free(cpdmol->atom);
    cpdmol->atom = NULL;
  }
  if (cpdmol->bond != NULL){
    for (i = 0; i < cpdmol->bondnum; i++){
      if (cpdmol->bond[i].prop != NULL){
        free(cpdmol->bond[i].prop);
      }
    }
    free(cpdmol->bond);
    cpdmol->bond = NULL;
  }

  return;
}

/*
 ƸҤη缡¤ȿǿ
   ι¤¦ϡnumH + numDefi
   ʬ¤¦ϡnumHѤ
*/
void calc_valence(CPDMOL* cpdmol){
  int i, j;
  int count;
  int arom;

  cpdmol->atomnum_sub = 0;

  for (i = 0; i < cpdmol->atomnum; i++){
    count = 0;
    arom = _NO_;
    cpdmol->atom[i].numH = 0;
    cpdmol->atom[i].valence = 0;

    if (cpdmol->atom[i].atomno > 1) cpdmol->atomnum_sub++;

    for (j = 0; j < cpdmol->atom[i].bondnum; j++){
      switch(cpdmol->bond[cpdmol->atom[i].bond[j]].order){
      case 1:
        count += 1;
        break;
      case 2:
        count += 2;
        break;
      case 3:
        count += 3;
        break;
      case 4:
        count += 1;
        arom = _YES_;
        break;
      default:
        count += 1;
        break;
      }
    }
    if (arom == _YES_) count++;
    count -= cpdmol->atom[i].charge;

    switch(cpdmol->atom[i].atomno){
    case  6: /* C */
      cpdmol->atom[i].valence = 4;
      break;
    case  7: /* N */
      if (count <= 3){
        cpdmol->atom[i].valence = 3;
      } else {
        cpdmol->atom[i].valence = 5;
      }
      break;
    case  8: /* O */
      cpdmol->atom[i].valence = 2;
      break;
    case 15: /* P */
      if (count <= 3){
        cpdmol->atom[i].valence = 3;
      } else {
        cpdmol->atom[i].valence = 5;
      }
      break;
    case 16: /* S */
      if (count <= 2){
        cpdmol->atom[i].valence = 2;
      } else
      if (count <= 4){
        cpdmol->atom[i].valence = 4;
      } else {
        cpdmol->atom[i].valence = 6;
      }
      break;
    }

    /* ĤƤʤ */
    cpdmol->atom[i].numDefi = cpdmol->atom[i].valence - count;
    if (cpdmol->atom[i].numDefi < 0) cpdmol->atom[i].numDefi = 0;

    /* ꤬줿Ǥʤ */
    for (j = 0; j < cpdmol->atom[i].bondnum; j++){
      int pair = pairAtom(cpdmol, cpdmol->atom[i].bond[j], i + 1);
      if (pair > 0 && cpdmol->atom[pair - 1].atomno == 1)
        cpdmol->atom[i].numH++;
    }
  }
}

/*
 ƸҤǷֹǥ()
 ȤȤϷϿ
*/
void sort_bondatom(CPDMOL *mol){
  int i, j, k;
  int t = 0;
  ATOM *atom;

  for (i = 0; i < mol->atomnum; i++){
    atom = &(mol->atom[i]);
    for (j = 0; j < atom->bondnum - 1; j++){
      for (k = j + 1; k < atom->bondnum; k++){
        if (mol->bond[atom->bond[j]].a1 + mol->bond[atom->bond[j]].a2 >
            mol->bond[atom->bond[k]].a1 + mol->bond[atom->bond[k]].a2){
          t             = atom->bond[j];
          atom->bond[j] = atom->bond[k];
          atom->bond[k] = t;
        }
      }
    }
  }
}

/* ޥȥå */
void make_bondmatrix(int bondnum, int **bonds, char **matrix){
  int i;
  int a1, a2;
  int order = 0;

  /* NULLåɬפݽƤʤФˤʤϤ */

  for (i = 0; i < bondnum; i++){
    a1 = bonds[i][_BOND_ATOM1_];
    a2 = bonds[i][_BOND_ATOM2_];
    order = bonds[i][_BOND_ORDER_];

    matrix[a1 - 1][a2 - 1] = (char)order;
    matrix[a2 - 1][a1 - 1] = (char)order;
  }
}
/* 
 ()Ƚ(ʬ¤Ѥν§̵)
    оݸǤ   CNS(IV)P
    оݸҤγƷ򻰼٥ȥ(vector3)ɽ
    a, b, c, dȤ롣
    ʬ¤ƸҤ˥ޥåι¤¦ҤƤǤ뤳ȤݾڤʤΤ
    ɽǤоϥåʤ
    ΤȤν֤ϥȺѤߤȤ롣
    ʬ¤õξϡ¦ǤϤʤ¤ΥʥХ󥰽Ǥޤʤ
    atom-atom mappingбʬ¤¦γƸҤȸ礨Хޥå
*/
void checkNegaPos(CPDMOL *pmol, int is3D){
  int i, j;
  ATOM *atom;
  BOND *bond;
  int flag;
  int a[4];
  double v[4][3];
  double val;

  /*  */
  for (i = 0; i < pmol->atomnum; i++){
    if (is3D == _NO_){ /* up/downˤʤΤǽͤƥʥ */
      pmol->atom[i].chiral = _CHIRAL_ZERO_;
    } else {
      pmol->atom[i].chiral = _CHIRAL_UNKNOWN_;
    }
  }

  if (is3D == _NO_){ /* up/downλΤ븶 */
    for (i = 0; i < pmol->bondnum; i++){
      bond = &(pmol->bond[i]);
      if (bond->stereo != 0){
        pmol->atom[bond->a1 - 1].chiral = _CHIRAL_UNKNOWN_;
        pmol->atom[bond->a2 - 1].chiral = _CHIRAL_UNKNOWN_;
      }
    }
  }

  for (i = 0; i < pmol->atomnum; i++){
    atom = &(pmol->atom[i]);
    if (atom->chiral != _CHIRAL_UNKNOWN_) continue;

    flag = _NO_;
    /* оݸǤ   CNSP */
    switch(atom->atomno){
    case  6:
    case  7:  /* ξǤΤ??? */
    case 15:
      if (atom->bondnum == 3 && atom->numH == 0) flag = _YES_;
      else
      if (atom->bondnum == 4 && atom->numH <  2) flag = _YES_;
      break;
    case 16:
      if (atom->valence == 4 && atom->bondnum == 3 && atom->numH == 0) flag = _YES_;
      break;
    default:
      break;
    }

    if (flag == _NO_){
      atom->chiral = _CHIRAL_ZERO_;
      continue;
    }

    /* ֹ */
    for (j = 0; j < atom->bondnum; j++)
      a[j] = pairAtom(pmol, atom->bond[j], i + 1);

    /* ƸҤΥ٥ȥ */
    for (j = 0; j < atom->bondnum; j++){
      v[j][0] = pmol->atom[a[j] - 1].x - atom->x;
      v[j][1] = pmol->atom[a[j] - 1].y - atom->y;
      if (is3D == _NO_){
        v[j][2] = 0.0;
      } else {
        v[j][2] = pmol->atom[a[j] - 1].z - atom->z;
      }
    }

    if (is3D == _NO_){ /* up/downˤ */
      for (j = 0; j < atom->bondnum; j++){
        switch(pmol->bond[atom->bond[j]].stereo){
        case 1:   /* UP */
          if (pmol->bond[atom->bond[j]].a1 - 1 == i){ /* atom1 | atom2 */
            v[j][2] += 1.0;
          } else {
            v[j][2] -= 1.0;
          }
          break;
        case 6:   /* DOWN */
          if (pmol->bond[atom->bond[j]].a1 - 1 == i){ /* atom1 | atom2 */
            v[j][2] -= 1.0;
          } else {
            v[j][2] += 1.0;
          }
          break;
        }
      }
    }

    /*  ꤬3ʤпǸҤΥ٥ȥ */
    if (atom->bondnum == 3){
      for (j = 0; j < 3; j++)
        v[3][j] = (v[0][j] + v[1][j] + v[2][j]) / (-3.0);
    }

    val = calcRotation(v);
    if (fabs(val) < _NEARLY_ZERO_){
      atom->chiral = _CHIRAL_ZERO_;
    } else
    if (val > 0.0){
      if (atom->bondnum == 3)
        atom->chiral = _CHIRAL_POS3_;
      else
        atom->chiral = _CHIRAL_POS4_;
    } else {
      if (atom->bondnum == 3)
        atom->chiral = _CHIRAL_NEG3_;
      else
        atom->chiral = _CHIRAL_NEG4_;
    }
  }
}

/* (ŷ)Ƚ(ʬ¤Ѥν§̵) */
void checkCisTrans(CPDMOL *pmol){
  int i, j;
  ATOM *atom1 = NULL;  /* atom1-atom2=atom3-atom4atom2atom3ֹ椬㤤 */
  ATOM *atom2 = NULL;  /* atom1ϡatom2η(atom3ʳ)ǡֹ椬㤤 */
  ATOM *atom3 = NULL;  /* atom4ϡatom3η(atom2ʳ)ǡֹ椬㤤 */
  ATOM *atom4 = NULL;
  BOND *bond  = NULL;
  int a1, a2, a3, a4;  /* Ҥֹ1 */
  int b;
  double c1[3], c2[3], c3[3], c4[3];
  double torsion;

  for (i = 0; i < pmol->bondnum; i++){
    bond = &(pmol->bond[i]);
    if (bond->geometry != _GEOMETRY_NONE_) continue;
    if (bond->order == 2){  /* ŷǤʤԲ */
      if (bond->a1 < bond->a2){  /* atom2atom3 */
        a2 = bond->a1;
        a3 = bond->a2;
      } else {
        a2 = bond->a2;
        a3 = bond->a1;
      }

      atom2 = &(pmol->atom[a2 - 1]);
      atom3 = &(pmol->atom[a3 - 1]);
      /* ŷʳη礬1Ĥ2ĤǤʤcis/transζ̤Ωʤ */
      if (atom2->bondnum < 2 || atom2->bondnum > 3) continue;
      if (atom3->bondnum < 2 || atom3->bondnum > 3) continue;

      /* atom1 */
      a1 = a4 = -1;
      for (j = 0; j < atom2->bondnum; j++){
        if (atom2->bond[j] == i) continue;
        b = atom2->bond[j];
        if (pmol->bond[b].stereo == 4) continue;  /* eitherξ硢cis/transζ̤Ωʤ */
        if (a1 < 0) a1 = pairAtom(pmol, b, a2);
        else        a4 = pairAtom(pmol, b, a2);
      }
      if (a1 < 0) continue;
//printf("(%d %d)", a1 + 1, a4 + 1);
      if (a4 < 0){
        atom1 = &(pmol->atom[a1 - 1]);
      } else {
        if (a1 < a4) atom1 = &(pmol->atom[a1 - 1]);
        else         atom1 = &(pmol->atom[a4 - 1]);
      }

      /* atom4 */
      a1 = a4 = -1;
      for (j = 0; j < atom3->bondnum; j++){
        if (atom3->bond[j] == i) continue;
        b = atom3->bond[j];
        if (pmol->bond[b].stereo == 4){  /* eitherξ硢cis/transζ̤Ωʤ */
          a1 = -1;
          break;
        }
        if (a1 < 0) a1 = pairAtom(pmol, b, a3);
        else        a4 = pairAtom(pmol, b, a3);
      }
      if (a1 < 0) continue;
      if (a4 < 0){
        atom4 = &(pmol->atom[a1 - 1]);
      } else {
        if (a1 < a4) atom4 = &(pmol->atom[a1 - 1]);
        else         atom4 = &(pmol->atom[a4 - 1]);
      }
//printf(" - %d = %d - (%d %d)\n", a2 + 1, a3 + 1, a4 + 1, a1 + 1);

      /* γѤ */
      /* 90deg꾮Сzusammen */
      /* 90deg礭Сentgegen */
      /* äȤγѤ90degᤤȤꤷʤ */
      c1[0] = atom1->x;
      c1[1] = atom1->y;
      c1[2] = atom1->z;
      c2[0] = atom2->x;
      c2[1] = atom2->y;
      c2[2] = atom2->z;
      c3[0] = atom3->x;
      c3[1] = atom3->y;
      c3[2] = atom3->z;
      c4[0] = atom4->x;
      c4[1] = atom4->y;
      c4[2] = atom4->z;
      torsion = torsionAngle(c1, c2, c3, c4);
//printf(" torsion = %10.4f ", torsion);
      if (torsion > 900.0 || torsion < -900.0){
        bond->geometry = _GEOMETRY_NONE_;
      } else
      if (torsion < _PI_HALF_){
        bond->geometry = _GEOMETRY_ZUSAMMEN_;
      } else {
        bond->geometry = _GEOMETRY_ENTGEGEN_;
      }
//printf(" %d\n", bond->geometry);
    }
  }

 return;
}

/* ۰̷ */
/*   [N+]-[O-]  N=O */
/*   [S+]-[O-]  S=O */
/*   [N+]=[N-]  N#N  ex) -N=[N+]=[N-] */
void correctCoordinate(int bondnum, char **atoms, int **bonds){
  int i;

  for (i = 0; i < bondnum; i++){
    if (bonds[i][_BOND_ORDER_] == 4) continue;
    if (atoms[bonds[i][_BOND_ATOM1_] - 1][_ATOM_CHARGE_] - _CHARGE_OFFSET_ > 0 &&
        atoms[bonds[i][_BOND_ATOM2_] - 1][_ATOM_CHARGE_] - _CHARGE_OFFSET_ < 0){
      atoms[bonds[i][_BOND_ATOM1_] - 1][_ATOM_CHARGE_]--;        /* Ų٤ */
      atoms[bonds[i][_BOND_ATOM2_] - 1][_ATOM_CHARGE_]++;        /* Ų٤ */
      if (atoms[bonds[i][_BOND_ATOM1_] - 1][_ATOM_VALENCE_] != 0)
        atoms[bonds[i][_BOND_ATOM1_] - 1][_ATOM_VALENCE_] += 2;  /*  */
      bonds[i][_BOND_ORDER_]++;
    } else
    if (atoms[bonds[i][_BOND_ATOM1_] - 1][_ATOM_CHARGE_] - _CHARGE_OFFSET_ < 0 &&
        atoms[bonds[i][_BOND_ATOM2_] - 1][_ATOM_CHARGE_] - _CHARGE_OFFSET_ > 0){
      atoms[bonds[i][_BOND_ATOM1_] - 1][_ATOM_CHARGE_]++;        /* Ų٤ */
      atoms[bonds[i][_BOND_ATOM2_] - 1][_ATOM_CHARGE_]--;        /* Ų٤ */
      if (atoms[bonds[i][_BOND_ATOM2_] - 1][_ATOM_VALENCE_] != 0)
        atoms[bonds[i][_BOND_ATOM2_] - 1][_ATOM_VALENCE_] += 2;  /*  */
      bonds[i][_BOND_ORDER_]++;
    }
  }
}

/*  ǵ椫顢ֹ֤ */
int getAtomNo(char *label){
  int atomno = 0; /* ֹ0 */
  int i      = 0;

  if (strcmp(label, _ATOMSYMBOL_ASTERISK_) == 0) return _ATOMNUMBER_ASTERISK_;
  if (strcmp(label, _ATOMSYMBOL_H_PLUS_  ) == 0) return _ATOMNUMBER_H_PLUS_;
  if (strcmp(label, _ATOMSYMBOL_R_       ) == 0) return _ATOMNUMBER_R_;
  if (strcmp(label, _ATOMSYMBOL_R_SHARP_ ) == 0) return _ATOMNUMBER_R_SHARP_;
  if (strcmp(label, _ATOMSYMBOL_X_       ) == 0) return _ATOMNUMBER_X_;

  for(i = 1; i <= ATOM_NO_MAX; i++){
    if (strcmp(label, atom_label[i]) == 0){
      atomno = i;
      break;
    }
  }

  return atomno;
}

/*  ֹ椫顢ǵ֤ */
void getLabel(int no, char *buff){
  switch(no){
  case _ATOMNUMBER_ASTERISK_:
    strcpy(buff, _ATOMSYMBOL_ASTERISK_);
    break;
  case _ATOMNUMBER_H_PLUS_:
    strcpy(buff, _ATOMSYMBOL_H_PLUS_);
    break;
  case _ATOMNUMBER_R_:
  /*
  case _ATOMNUMBER_R_SHARP_:
   */
    strcpy(buff, _ATOMSYMBOL_R_);
    break;
  case _ATOMNUMBER_X_:
    strcpy(buff, _ATOMSYMBOL_X_);
    break;
  default:
    strcpy(buff, atom_label[no]);
    break;
  }
  return;
}

int pairAtom(CPDMOL* cpdmol, int bno, int a1){
  if (cpdmol->bond[bno].a1 == a1) return cpdmol->bond[bno].a2;
  if (cpdmol->bond[bno].a2 == a1) return cpdmol->bond[bno].a1;
  return -1;
}

