/*
  DBɽ
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define _ATOM_ARRAY_     5
#define _BOND_ARRAY_     4
/* private function */

int main(int argc, char **argv){
  int i;
  FILE *fidx;
  FILE *ftyp;
  FILE *fdat;
  char buff[BUFSIZ];
  int atomnum, atomnum_sub, bondnum;
  long pos[2];
  char idstr[81];
  char atom[_ATOM_ARRAY_];
  int bond[_BOND_ARRAY_];

  pos[0] = pos[1] = 0L;

  /* β */
  if (argc < 2){
    printf("What?\n");
    exit(0);
  }

  sprintf(buff, "%s.idx", argv[1]);
  fidx = fopen(buff, "rb");
  sprintf(buff, "%s.typ", argv[1]);
  ftyp = fopen(buff, "rb");
  sprintf(buff, "%s.dat", argv[1]);
  fdat = fopen(buff, "rb");
  if (fidx == NULL || ftyp == NULL || fdat == NULL){
    printf("Can not open\n");
    exit(0);
  }

  fread(idstr, sizeof(char), 80, fidx);
  fread(pos, sizeof(long), 2, fidx);
  while(feof(fidx) == 0){
    if (pos[0] > 0L && pos[1] > 0L){
      printf("[ID] : %s\n (%ld, %ld)\n", idstr, pos[0], pos[1]);

      fseek(ftyp, pos[0], SEEK_SET);
      fread(&atomnum, sizeof(int), 1, ftyp);
      fread(&atomnum_sub, sizeof(int), 1, ftyp);
      fread(&bondnum, sizeof(int), 1, ftyp);
      printf("atom %d(%d) : bond %d\n", atomnum, atomnum_sub, bondnum);
      printf("[atom]\n");
      for (i = 0; i < atomnum; i++){
        fread(atom, sizeof(char), _ATOM_ARRAY_, ftyp);
        printf(" %d, %d, %d, %d, %d\n", atom[0], atom[1], atom[2], atom[3], atom[4]);
      }

      fseek(fdat, pos[1], SEEK_SET);
      printf("[bond]\n");
      for (i = 0; i < bondnum; i++){
        fread(bond, sizeof(int), _BOND_ARRAY_, fdat);
        printf(" %d, %d, %d, %d\n", bond[0], bond[1], bond[2], bond[3]);
      }
    }
    fread(idstr, sizeof(char), 80, fidx);
    fread(pos, sizeof(long), 2, fidx);
  }

  fclose(fidx);
  fclose(ftyp);
  fclose(fdat);

  exit(0);
}

