/*
  KCF񼰤ɤ߹
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "subcomp.h"

void terminalCheck(CPDMOL *, int, int *);
int searchSimpleRing(CPDMOL *, int *, int *, int, int, int);

CPDMOL *read_CPDMOL_KCF(FILE *fp){
  CPDMOL *ret;
  char buff[BUFSIZ];
  char s1[BUFSIZ];
  char s2[BUFSIZ];
  char s3[BUFSIZ];
  char s4[BUFSIZ];
  int dummy;
  int rcode;
  int i;
  int j;
  int idx1;
  int idx2;

  /* ENTRYԤɤ߹ */
  if (fgets(buff, sizeof(buff), fp) == NULL) return NULL;
  if (strncmp(buff, "ENTRY", 5) != 0) return NULL;

  ret = (CPDMOL *)malloc(sizeof(CPDMOL));
  memset(ret, 0, sizeof(CPDMOL));
  if (ret == NULL) return ret;

  if ((rcode = sscanf(buff, "%s %s", s1, s2)) != 2) return ret;
  ret->name = (char *)malloc(sizeof(char) * (strlen(s2) + 1));
  if (ret->name == NULL) return ret;
  memset(ret->name, 0, sizeof(char) * (strlen(s2) + 1));
  strcpy(ret->name, s2);

  /* NAMEԤɤ߹ */
  if(fgets(buff, sizeof(buff), fp) == NULL) return ret;
  if(strncmp(buff, "NAME", 4) == 0){
    if (strlen(buff) > 12){
      sscanf(&buff[12], "%s", s1);
      if (strlen(s1) > 0){
        ret->definition = (char *)malloc(sizeof(char) * (strlen(s1) + 1));
        if (ret->definition == NULL) return ret;
        memset(ret->definition, 0, sizeof(char) * (strlen(s1) + 1));
        strcpy(ret->definition, s1);
      }
    }
  } else {
    ret->definition = NULL;
  }

  /* ҾؤƬФ */
  while(strncmp(buff, "ATOM", 4) != 0 && strncmp(buff, "///", 3) != 0)
    if (fgets(buff, sizeof(buff), fp) == NULL) break;
  if (strncmp(buff, "///", 3) == 0) return ret;

  /* ҿ */
  sscanf(buff, "%s %d", s1, &(ret->atomnum));
  if (ret->atomnum > 0){
    ret->atom = (ATOM *)malloc(sizeof(ATOM) * ret->atomnum);
    if (ret->atom == NULL){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    memset(ret->atom, 0, sizeof(ATOM) * ret->atomnum);
  }

  /* Ҿɤ߹ */
  for (i = 0; i < ret->atomnum; i++){
    if (fgets(buff, sizeof(buff), fp) == NULL){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    if(strncmp(buff, "///", 3) == 0){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    if(buff[0] != ' ' && buff[0] != '\t' && buff[0] != '\n') break;

    s1[0] = '\0';
    s2[0] = '\0';
    s3[0] = '\0';
    s4[0] = '\0';
    if ((rcode = sscanf(buff, "%d %s %s %lf %lf %s %s", &dummy, s1, s2, &(ret->atom[i].x), &(ret->atom[i].y), s3, s4)) < 5){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    if (strlen(s1) > _NID_LENGTH_ || strlen(s2) > _AID_LENGTH_){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    strcpy(ret->atom[i].nid, s1);
    strcpy(ret->atom[i].aid, s2);
    ret->atom[i].atomno = getAtomNo(s2);

    if (rcode > 5 && strlen(s3) > 0){
      ret->atom[i].prop1 = (char *)malloc(sizeof(char) * (strlen(s3) + 1));
      if (ret->atom[i].prop1 == NULL){
        ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
        return ret;
      }
      memset(ret->atom[i].prop1, 0, sizeof(char) * (strlen(s3) + 1));
      strcpy(ret->atom[i].prop1, s3);

      /* Ųپå */
      if (s3[0] == '#'){
        if (s3[strlen(s3) - 1] == '+'){
          ret->atom[i].charge = atoi(s3 + 1);
          if (ret->atom[i].charge == 0) ret->atom[i].charge = 1;
        } else
        if (s3[strlen(s3) - 1] == '-'){
          ret->atom[i].charge = atoi(s3 + 1) * -1;
          if (ret->atom[i].charge == 0) ret->atom[i].charge = -1;
        }
      }
    }
    if (rcode > 6 && strlen(s4) > 0){
      ret->atom[i].prop2 = (char *)malloc(sizeof(char) * (strlen(s4) + 1));
      if (ret->atom[i].prop2 == NULL){
        ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
        return ret;
      }
      memset(ret->atom[i].prop2, 0, sizeof(char) * (strlen(s4) + 1));
      strcpy(ret->atom[i].prop2, s4);

      /* Ųپå */
      if (s4[0] == '#'){
        if (s4[strlen(s4) - 1] == '+'){
          ret->atom[i].charge = atoi(s4 + 1);
          if (ret->atom[i].charge == 0) ret->atom[i].charge = 1;
        } else
        if (s4[strlen(s4) - 1] == '-'){
          ret->atom[i].charge = atoi(s4 + 1) * -1;
          if (ret->atom[i].charge == 0) ret->atom[i].charge = -1;
        }
      }
    }
  }

  /* ؤƬФ */
  while(strncmp(buff, "BOND", 4) != 0 && strncmp(buff, "///", 3) != 0)
    if (fgets(buff, sizeof(buff), fp) == NULL) break;
  if(strncmp(buff, "///", 3) == 0) return ret;

  /*  */
  sscanf(buff, "%s %d", s1, &(ret->bondnum));
  if (ret->bondnum > 0){
    ret->bond = (BOND *)malloc(sizeof(BOND) * ret->bondnum);
    if (ret->bond == NULL){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    memset(ret->bond, 0, sizeof(BOND) * ret->bondnum);
  }

  /* ɤ߹ */
  for (i = 0; i < ret->bondnum; i++){
    if (fgets(buff, sizeof(buff), fp) == NULL){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    if(strncmp(buff, "///", 3) == 0){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    if(buff[0] != ' ' && buff[0] != '\t' && buff[0] != '\n') break;

    s1[0] = '\0';
    if ((rcode = sscanf(buff, "%d %d %d %d %s",
        &dummy, &(ret->bond[i].a1), &(ret->bond[i].a2),
        &(ret->bond[i].order), s1)) < 4) continue;

    if (rcode > 4 && strlen(s1) > 0){
      ret->bond[i].prop = (char *)malloc(sizeof(char) * (strlen(s1) + 1));
      if (ret->bond[i].prop == NULL){
        ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
        return ret;
      }
      memset(ret->bond[i].prop, 0, sizeof(char) * (strlen(s1) + 1));
      strcpy(ret->bond[i].prop, s1);
      if (strcasecmp(s1, "#UP") == 0){
        ret->bond[i].stereo = _BOND_UP_;
      } else
      if (strcasecmp(s1, "#DOWN") == 0){
        ret->bond[i].stereo = _BOND_DOWN_;
      } else
      if (strcasecmp(s1, "#EITHER") == 0){
        ret->bond[i].stereo = _BOND_EITHER_;
      }
    }
    if ((ret->bond[i].a1 > 0 && ret->bond[i].a1 <= ret->atomnum) &&
        (ret->bond[i].a2 > 0 && ret->bond[i].a2 <= ret->atomnum)){
      ret->atom[ret->bond[i].a1 - 1].bondnum++;
      ret->atom[ret->bond[i].a2 - 1].bondnum++;
    }
  }

  /* ǥߥޤǿʤ */
  while(strncmp(buff, "///", 3) != 0) 
    if (fgets(buff, sizeof(buff), fp) == NULL) break;

  /* ATOM¤ΤˡҤ˴ϢƤʬΰ */
  for (i = 0; i < ret->atomnum; i++){
    ret->atom[i].bond = (int *)malloc(sizeof(int) * ret->atom[i].bondnum);
    if (ret->atom[i].bond == NULL){
      ret->atomnum = 0;  /* 0ˤСʹߤνʤʤ */
      return ret;
    }
    memset(ret->atom[i].bond, -1, sizeof(int) * ret->atom[i].bondnum);
  }

  /* ʬҥǡηֹ(ƬINDEX 0) */
  for (i = 0; i < ret->bondnum; i++){
    idx1 = ret->bond[i].a1 - 1;
    idx2 = ret->bond[i].a2 - 1;

    for (j = 0; j < ret->atom[idx1].bondnum; j++){
      if (ret->atom[idx1].bond[j] == -1){
         ret->atom[idx1].bond[j] = i;
         break;
      }
    }
    for (j = 0; j < ret->atom[idx2].bondnum; j++){
      if (ret->atom[idx2].bond[j] == -1){
         ret->atom[idx2].bond[j] = i;
         break;
      }
    }
  }

  return ret;
}

/* ҥפ˧ľ󤫤顢Ʒ礬˧ĤȽǤ */
void arom_checkKCF(CPDMOL* cpdmol){
  int i, j;
  int *workflag = NULL; /* õϩ */
  int *bondflag = NULL; /* üηǤ0ĤޤéäƤ̣Τʤ*/

  workflag = (int *)malloc(sizeof(int) * cpdmol->bondnum);
  bondflag = (int *)malloc(sizeof(int) * cpdmol->bondnum);
  if (workflag == NULL || bondflag == NULL) return;

  /* ҥפꡢƸҤ˧Ĥ */
  for (i = 0; i < cpdmol->atomnum; i++){
    if (strncmp(cpdmol->atom[i].nid, "C8", 2) == 0 ||
        strncmp(cpdmol->atom[i].nid, "N4", 2) == 0 ||
        strncmp(cpdmol->atom[i].nid, "N5", 2) == 0 ||
        strncmp(cpdmol->atom[i].nid, "O1", 2) == 0 ||
        strncmp(cpdmol->atom[i].nid, "O2", 2) == 0 ||
        strncmp(cpdmol->atom[i].nid, "O7", 2) == 0 ||
        strncmp(cpdmol->atom[i].nid, "O0", 2) == 0 ||
        strcmp(cpdmol->atom[i].aid, "S") == 0 ||
        strcmp(cpdmol->atom[i].aid, "P") == 0){
      cpdmol->atom[i].arom = _YES_;
    } else {
      cpdmol->atom[i].arom = _NO_;
    }
  }

  /*  */
  for (i = 0; i < cpdmol->bondnum; i++){
    workflag[i] = _NO_;
    /* ξü˧ĤǤʤʤоݳ */
    if (cpdmol->atom[cpdmol->bond[i].a1 - 1].arom == _YES_ &&
        cpdmol->atom[cpdmol->bond[i].a2 - 1].arom == _YES_){
      bondflag[i] = _YES_;
    } else {
      bondflag[i] = _NO_;
    }
  }

  /* üõüηоݳ */
  for (i = 0; i < cpdmol->bondnum; i++)
   if (bondflag[i] == _YES_) terminalCheck(cpdmol, i, bondflag);

  for (i = 0; i < cpdmol->bondnum; i++){
    if (bondflag[i] == _NO_) continue;
    if (cpdmol->bond[i].arom == _YES_) continue;
    for (j = 0; j < cpdmol->bondnum; j++) workflag[j] = _NO_;
    workflag[i] = 1;
    searchSimpleRing(cpdmol, bondflag, workflag, cpdmol->bond[i].a1, cpdmol->bond[i].a2, 2);
  }

  free(workflag);
  free(bondflag);
}

/* üõĹ¤ˤʤüηоݳ */
void terminalCheck(CPDMOL* cpdmol, int bno, int* bondflag){
  int num1, num2, a1, a2;
  ATOM *atom1, *atom2;

  a1 = cpdmol->bond[bno].a1;
  a2 = cpdmol->bond[bno].a2;
  atom1 = &(cpdmol->atom[a1 - 1]);
  atom2 = &(cpdmol->atom[a2 - 1]);
  num1 = atom1->bondnum;
  num2 = atom2->bondnum;

  if (num1 == 1 && num2 == 1){
    bondflag[bno] = _NO_;
    return;
  } else
  if (num1 == 1){
    bondflag[bno] = _NO_;
    if (num2 == 2){
      if (pairAtom(cpdmol, atom2->bond[0], a2) == a1){
        if (bondflag[atom2->bond[1]] == _YES_)
          terminalCheck(cpdmol, atom2->bond[1], bondflag);
      } else {
        if (bondflag[atom2->bond[0]] == _YES_)
          terminalCheck(cpdmol, atom2->bond[0], bondflag);
      }
    }
  } else
  if (num2 == 1){
    bondflag[bno] = _NO_;
    if (num2 == 2){
      if (pairAtom(cpdmol, atom1->bond[0], a2) == a1){
        if (bondflag[atom1->bond[1]] == _YES_)
          terminalCheck(cpdmol, atom1->bond[1], bondflag);
      } else {
        if (bondflag[atom1->bond[0]] == _YES_)
          terminalCheck(cpdmol, atom1->bond[0], bondflag);
      }
    }
  }
  return;
}

 /**
  * õʰ(Ƶ)
  * ȤʤäФ˧Ĥ1ĤǤ⸫դOK
  */
int searchSimpleRing(CPDMOL* cpdmol, int* bondflag, int* workflag, int start, int now, int gen){
  int i, j;

  for (i = 0; i < cpdmol->bondnum; i++){
    if (bondflag[i] == _NO_) continue;
    if (workflag[i] != 0) continue;
    if (pairAtom(cpdmol, i, now) > 0){
      workflag[i] = gen;
      if (pairAtom(cpdmol, i, start) > 0){
        /* ĤĤ */
        for (j = 0; j < cpdmol->bondnum; j++)
          if (workflag[j] != 0) cpdmol->bond[j].arom = _YES_;
        return _YES_;
      } else {
        /* õ */
        if (searchSimpleRing(cpdmol, bondflag, workflag, start, pairAtom(cpdmol, i, now), gen + 1) == _YES_) return _YES_;
      }
      workflag[i] = 0;
    }
  }

  return _NO_;
}


