/*
  match.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "subcomp.h"

/* private function */
int rsearch(int);                 /* ʬ¤ι¤νŤ͹碌Ƶ */
int refine(unsigned int **);      /* matching_matrix
                                     ǤΡɿ֤
                                     줫ʬ¤ҤΥΡɤǤ-1 */
int is_zero(unsigned int *, int); /* ӥåall 0ɤ */
int addRESULT();                  /* ޥå̤Ͽ */
int checkChiral();
int checkEZ();

static SUBCOMP *subcomp;          /* ƵƽФǻȤ뤿static */
static unsigned int **mat;        /* ޥå󥰥ޥȥå */
static int mode;                  /* ޥå󥰥⡼(SUB/SUP) */

void setMATRIX(SUBCOMP *sub, int match_mode){
  int i, j;

  /* staticѿ򡡥åȤѤäƤѲ̵ */
  subcomp = sub;
  mat = subcomp->m;
  mode = match_mode;

  for (i = 0; i < subcomp->Patomnum; i++){
    /* ʬ¤¦̤ǤХå */
    if (subcomp->Patoms[i][_ATOM_ATOMNO_] == (char)0)
      continue;

    for (j = 0; j < subcomp->Watomnum; j++){
      /* ֹ */
      if (subcomp->Patoms[i][_ATOM_ATOMNO_] != subcomp->Watoms[j][_ATOM_ATOMNO_])
        continue;

      /* ǿ(SUB⡼ɸ) */
      if (mode == _MA_SUB_ &&
          subcomp->Patoms[i][_ATOM_HYDROGEN_] > subcomp->Watoms[j][_ATOM_HYDROGEN_])
        continue;

      /* Ų */
      if (subcomp->opt_charge == _YES_ &&
          subcomp->Patoms[i][_ATOM_CHARGE_] != subcomp->Watoms[j][_ATOM_CHARGE_])
        continue;

      /*  */
      if (subcomp->opt_valence == _YES_ &&
          subcomp->Patoms[i][_ATOM_VALENCE_] != subcomp->Watoms[j][_ATOM_VALENCE_])
        continue;

      on_bit(mat[i], j);
    }
  }
}

void search(){
  int ret = 0;

  /* ޤmatching_matrixå */
  for (;;) {
    ret = refine(mat);

    if (ret == 0) break;
    if (ret < 0) return;
  }

  rsearch(0);
}

/* õоʬ¤Ҥ˽Ť͹碌ǽʡι¤θҤ֤ */
int find(unsigned int **m, int depth, int last){
  int i;

  for (i = last + 1; i < subcomp->m_col; i++){
    if (is_on(m[depth], i) != 0 &&
        is_on(subcomp->f_used, i) == 0)
      return i;
  }

  return -1;
}

/* ʬ¤ι¤νŤ͹碌Ƶ */
int rsearch(int depth){
  int i;
  int ret = 0;
  int t_no = -1;

  /* ⤷θҤǤʤ顡롼 */
  if (subcomp->Patoms[depth][_ATOM_ATOMNO_] == 1){
    /* õоqueryҤǸθҤ */
    if (depth + 1 >= subcomp->m_row){
      if (addRESULT() == _YES_){
        ret++;
        /* ޥåOKʤΤǤǽλ */
        return ret;
      }
    } else {
      ret = rsearch(depth + 1);
      return ret;
    }
  }

  /* ǽΡʬ¤ι¤θҽŤ͹碌פ */
  if (copyMATRIX(mat, subcomp->mm[depth], subcomp->m_row, subcomp->m_length) == _NO_) return -1;

  /* õоʬ¤Ҥ˽Ť͹碌ǽι¤θҤǥ롼 */
  for (;;){
    /* 򤷤ƤŤ͹碌Ф */
    if (copyMATRIX(subcomp->mm[depth], mat, subcomp->m_row, subcomp->m_length) == _NO_) return -1;

    /* ѺѤߤι¤Ҥ˳򥯥ꥢ */
    for (i = 0; i < subcomp->m_length; i++)
      mat[depth][i] &= ~subcomp->f_used[i];

    /* õоʬ¤Ҥ˽Ť͹碌ǽι¤θҤõ */
    t_no = find(mat, depth, t_no);

    /* Ĥʤнλ */
    if (t_no < 0) return ret;

    /* ι¤ҤѺѤߤ */
    on_bit(subcomp->f_used, t_no);

    /* ι¤ҤΤߤĤƱԡƱ򥯥ꥢ */
    for (i = 0; i < subcomp->m_length; i++)
      mat[depth][i] = 0;
    for (i = 0; i < subcomp->m_row; i++)
      if (i != t_no) off_bit(mat[i], t_no);

    on_bit(mat[depth], t_no);

    /* ʬ¤ι¤θҽŤ͹碌ιȥå */
    if (refine(mat) >= 0){
      /* õоʬ¤ҤǸθҤ */
      if (depth + 1 >= subcomp->m_row){
        /* ҽŤ͹碌ޥå̤Ͽ */
        if (addRESULT() == _YES_){
          ret++;
          /* ޥåOKʤΤǤǽλ */
          return ret;
        }
      } else {
        ret = rsearch(depth + 1);
        /* ޥåOKʤΤǥޥåƤнλ */
        if (ret > 0) return ret;
      }
    }

    /* ι¤Ҥ̤Ѥ᤹ */
    off_bit(subcomp->f_used, t_no);
  }

  return ret;
}

/* matching_matrix */
/* ǤΡɿ֤ */
/* 줫ʬ¤ҤΥΡɤǤ-1 */
int refine(unsigned int **m){
  int i, j, k, l;
  char order;
  int ok;
  int ret = 0;

  /* ʬ¤θҤǥ롼 */
  for (i = 0; i < subcomp->m_row; i++){
    /* Ǥϥå */
    if (subcomp->Patoms[i][_ATOM_ATOMNO_] == 1) continue;

    /* ʬ¤ҤȽŤ͹碌ǽι¤θҤĤäƤʤʤ   */
    if (is_zero(m[i], subcomp->m_length) == _YES_) return -1;

    /* ι¤θҤǥ롼 */
    for (j = 0; j < subcomp->m_col; j++){
      if (subcomp->Pbondnum == 0) continue;   /* ξPbondmatrix϶() */

      /* ʬ¤Ҥȸι¤ҤŤ͹碌ǽʤ  ƥå */
      if (is_on(m[i], j) != 0){

        /* ʬ¤Ҥǥ롼 */
        for (k = 0; k < subcomp->m_row; k++){
          /* Ǥϥå(KCFDBˤϿǤϴޤޤʤ) */
          if (subcomp->Patoms[k][_ATOM_ATOMNO_] == 1) continue;

          /* 礷Ƥʤʤ饹å */
          order = subcomp->Pbondmatrix[i][k];
          if (order == 0) continue;

          ok = _NO_;
          /* ι¤θҤǥ롼 */
          for (l = 0; l < subcomp->m_col; l++){
            /* ȽŤ͹碌ǽquery */
            if (is_on(m[k], l) != 0){
              /* 缡å */
              if (subcomp->Wbondmatrix[j][l] == order){
                ok = _YES_; /* Ť͹碌ǽ */
                break;
              }
            }
          }
          if (ok == _NO_){
            /* Ť͹碌ԲĤʤΤǤΥӥåȤoff */
            off_bit(m[i], j);
            /* ι¤ҤȽŤ͹碌ǽʬ¤θҤĤäƤʤʤ   */
            if (subcomp->Patoms[i][_ATOM_ATOMNO_] > 1 &&
                is_zero(m[i], subcomp->m_length) == _YES_) return -1;
            ret++;
            break;
          }
        }
      }
    }
  }

  return ret;
}

/* ޥå̤Ͽ */
int addRESULT(){
  int i, j;
  int no;
  RESULT *result = NULL;

  /* ޥå̤ΩΥå */
  if ((subcomp->opt_chiral & _CC_CHIRAL_) != 0)
    if (checkChiral() == _NO_) return _NO_;
  if ((subcomp->opt_chiral & _CC_GEOMETRY_) != 0)
    if (checkEZ() == _NO_) return _NO_;

  result = (RESULT *)malloc(sizeof(RESULT));
  if (result == NULL) return _NO_;
  memset(result, 0, sizeof(RESULT));

  strcpy(result->idstr, subcomp->idstr);
  if (mode == _MA_SUB_){ /* subcomptargetι¤ */
    result->atomnum = subcomp->Watomnum;
    result->atomnum_sub = subcomp->Watomnum_sub;
  } else {                              /* supcompqueryʬ¤ */
    result->atomnum = subcomp->Patomnum;
    result->atomnum_sub = subcomp->Patomnum_sub;
  }

  /* ΰ */
  result->map = (int *)malloc(sizeof(int) * subcomp->Patomnum);
  if (result->map == NULL){
    free(result);
    return _NO_;
  }
  result->atomicNO = (int *)malloc(sizeof(int) * subcomp->Patomnum);
  if (result->atomicNO == NULL){
    free(result->map);
    free(result);
    return _NO_;
  }

  /* atom-atom mappingθֹ */
  for (i = 0; i < subcomp->m_row; i++){
    if (subcomp->Patoms[i][_ATOM_ATOMNO_] <= 1){
      result->map[i] = -1;
      result->atomicNO[i] = 0;
    } else {
      no = -1;
      for (j = 0; j < subcomp->m_col; j++){
       if (is_on(subcomp->m[i], j) != 0){
         no = j;
         break;
       }
      }
      if (no < 0){ /* ޥåƤʤ */
        free(result->atomicNO);
        free(result->map);
        free(result);
        return _NO_;
      } else {
        result->map[i] = no;
        result->atomicNO[i] = subcomp->Watoms[no][_ATOM_ATOMNO_]; /*  */
      }
    }
  }

  result->mode = mode;
  result->score = (double)subcomp->Patomnum_sub / (double)subcomp->Watomnum_sub;

  /* Ϣ */
  if (subcomp->result_top == NULL){
    subcomp->result_top = result;
    subcomp->result_last = result;
    subcomp->resultnum++;
  } else {
    subcomp->result_last->next = result;
    result->prev = subcomp->result_last;
    subcomp->result_last = result;

    subcomp->resultnum++;
  }

  return _YES_;
}

/* ƤӽФrefine()Τ */
/* ӥåall 0Ǥ뤫ɤ */
int is_zero(unsigned int *bits, int length){
  int i;

  for (i = 0; i < length; i++)
    if (bits[i] != 0) return _NO_;

  return _YES_;
}

/* ޥå̤ΩΥå */
int checkChiral(){
  int i, j, k;
  int count;
  int pa[4];
  int wa[4];
  int wa0;
  int t = 0;
  double val;

//printf("start checkChiral()\n");
  for (i = 0; i < subcomp->Patomnum; i++){
    if (subcomp->Patoms[i][_ATOM_CHIRAL_] == _CHIRAL_ZERO_) continue;

    wa0 = -1;
    for (j = 0; j < subcomp->Watomnum; j++){
      if (is_on(mat[i], j) != 0){
        wa0 = j;
        break;
      }
    }

    /* ꤬ʤ(ȤƤʤchiralʿǸҡ) */
    if (wa0 < 0) return _NO_;

    /* ʬ¤ƤǤ⡢ι¤¦ҤƥʥʤOK */
    if (subcomp->Watoms[wa0][_ATOM_CHIRAL_] == _CHIRAL_ZERO_) continue;;

    for (j = 0; j < 4; j++){
      pa[j] = -1;     /* ʬ¤¦Ǥο */
      wa[j] = 9999;   /* ι¤¦Ǥο */
    }

    count = 0;
    for(j = 0; j < subcomp->Patomnum; j++){
      if (subcomp->Pbondmatrix[i][j] == 0) continue; /* ǤϤʤ */
      pa[count] = j;
      val = -1;  /* ꤬ʤν */
      for (k = 0; k < subcomp->Watomnum; k++){
        if (is_on(mat[j], k) != 0){
          val = k;
          break;
        }
      }
      wa[count] = val;    /* ι¤¦긶 */
      count++;
    }

   /* 3Ĥʬ¤Ҥ4Ĥι¤ҤȥޥåƤ */
   if (count == 3 &&
       (subcomp->Watoms[wa0][_ATOM_CHIRAL_] == _CHIRAL_POS4_ ||
        subcomp->Watoms[wa0][_ATOM_CHIRAL_] == _CHIRAL_NEG4_)){
     for (j = 0; j < subcomp->Watomnum; j++){
       if (subcomp->Wbondmatrix[wa0][j] != 0 &&
           j != wa[0] &&
           j != wa[1] &&
           j != wa[2]){
         wa[3] = j;
         break;
       }
     }
   }

   count = 0;  /* swapβ */
   /* ι¤¦θҽ˥ */
   for (j = 0; j < 3; j++){
     for (k = j + 1; k < 4; k++){
       if (wa[k] < 0) continue;   /* ʬ¤줿ǡι¤̵ҤϺǸ */
       if (wa[j] < 0 || wa[j] > wa[k]){
         t     = wa[j];
         wa[j] = wa[k];
         wa[k] = t;
         t     = pa[j];
         pa[j] = pa[k];
         pa[k] = t;
         count++;
       }
     }
   }

/*
for (j = 0; j < 4; j++){
printf(" %d - %d\n", pa[j], wa[j]);
}
*/

    switch(subcomp->Patoms[i][_ATOM_CHIRAL_]){
    case _CHIRAL_POS3_:
    case _CHIRAL_POS4_:
      switch(subcomp->Watoms[wa0][_ATOM_CHIRAL_]){
      case _CHIRAL_POS3_:
      case _CHIRAL_POS4_:
        if (count % 2 == 1) return _NO_;
        break;
      case _CHIRAL_NEG3_:
      case _CHIRAL_NEG4_:
        if (count % 2 == 0) return _NO_;
        break;
      }
      break;
    case _CHIRAL_NEG3_:
    case _CHIRAL_NEG4_:
      switch(subcomp->Watoms[wa0][_ATOM_CHIRAL_]){
      case _CHIRAL_POS3_:
      case _CHIRAL_POS4_:
        if (count % 2 == 0) return _NO_;
        break;
      case _CHIRAL_NEG3_:
      case _CHIRAL_NEG4_:
        if (count % 2 == 1) return _NO_;
        break;
      }
      break;
    }
  }

  return _YES_;
}

/* ޥå̤cis/transå */
int checkEZ(){
  int i, j;
  int pa1,  pa2,  pa3,  pa4;
  int wa1,  wa2,  wa3,  wa4;
  int wa11, wa12, wa41, wa42;
  int wbond;
  int t;
  int side2, side3;

//printf("start checkEZ()\n");
  for (i = 0; i < subcomp->Pbondnum; i++){
    if (subcomp->Pbonds[i][_BOND_GEOMETRY_] == _GEOMETRY_NONE_) continue;
//printf("bond %d %d\n", i + 1, subcomp->Pbonds[i][_BOND_GEOMETRY_]);

    /* ι¤¦θ */
    pa2 = subcomp->Pbonds[i][_BOND_ATOM1_] - 1;
    pa3 = subcomp->Pbonds[i][_BOND_ATOM2_] - 1;

    wa2 = -1;
    for (j = 0; j < subcomp->Watomnum; j++){
      if (is_on(mat[pa2], j) != 0){
        wa2 = j;
        break;
      }
    }
    wa3 = -1;
    for (j = 0; j < subcomp->Watomnum; j++){
      if (is_on(mat[pa3], j) != 0){
        wa3 = j;
        break;
      }
    }
//printf("wa2 = %d  wa3 = %d\n", wa2 + 1, wa3 + 1);
    /* ꤬ʤ(ȤƤʤ) */
    if (wa2 < 0 || wa3 < 0) return _NO_;

    if (wa2 > wa3){  /* ոʤ */
      t   = pa2;
      pa2 = pa3;
      pa3 = t;
      t   = wa2;
      wa2 = wa3;
      wa3 = t;
    }

    /* ι¤¦бå */
    /* ʬ¤Ƥʤ顢ι¤¦ƥʥͤǤϤꤨʤ(Ϥ) */
    wbond = -1;
    for (j = 0; j < subcomp->Wbondnum; j++){
      if ((subcomp->Wbonds[j][_BOND_ATOM1_] == wa2 + 1 &&
           subcomp->Wbonds[j][_BOND_ATOM2_] == wa3 + 1) ||
          (subcomp->Wbonds[j][_BOND_ATOM1_] == wa3 + 1 &&
           subcomp->Wbonds[j][_BOND_ATOM2_] == wa2 + 1)){
        wbond = j;
        break;
      }
    }
//printf("wbond = %d\n", wbond);
    if (wbond < 0) return _NO_;
    if (subcomp->Wbonds[wbond][_BOND_GEOMETRY_] == _GEOMETRY_NONE_) return _NO_;

    /* ʬ¤¦atom1atom4 */
    pa1 = pa4 = -1;

    /* atom1(ʣ뤬ϥʥХ󥰤μ㤤) */
    for (j = 0; j < subcomp->Patomnum; j++){
      if (j == pa2) continue;
      if (j == pa3) continue;
      if (subcomp->Pbondmatrix[pa2][j] == 0) continue;
      pa1 = j;
      break;
    }

    /* atom4(ʣ뤬ϥʥХ󥰤μ㤤) */
    for (j = 0; j < subcomp->Patomnum; j++){
      if (j == pa2) continue;
      if (j == pa3) continue;
      if (subcomp->Pbondmatrix[pa3][j] == 0) continue;
      pa4 = j;
      break;
    }

    /* ι¤¦atom1atom4 */
    wa11 = wa12 = wa41 = wa42 = -1;

    /* atom1atom4 */
    for (j = 0; j < subcomp->Wbondnum; j++){
      if (subcomp->Wbonds[j][_BOND_ATOM1_] == wa2 + 1){
        if (subcomp->Wbonds[j][_BOND_ATOM2_] != wa3 + 1){
          if (wa11 < 0) wa11 = subcomp->Wbonds[j][_BOND_ATOM2_] - 1;
          else          wa12 = subcomp->Wbonds[j][_BOND_ATOM2_] - 1;
        }
      } else
      if (subcomp->Wbonds[j][_BOND_ATOM1_] == wa3 + 1){
        if (subcomp->Wbonds[j][_BOND_ATOM2_] != wa2 + 1){
          if (wa41 < 0) wa41 = subcomp->Wbonds[j][_BOND_ATOM2_] - 1;
          else          wa42 = subcomp->Wbonds[j][_BOND_ATOM2_] - 1;
        }
      } else
      if (subcomp->Wbonds[j][_BOND_ATOM2_] == wa2 + 1){ /* _BOND_ATOM1_ wa3Ǥʤ() */
        if (wa11 < 0) wa11 = subcomp->Wbonds[j][_BOND_ATOM1_] - 1;
        else          wa12 = subcomp->Wbonds[j][_BOND_ATOM1_] - 1;
      } else
      if (subcomp->Wbonds[j][_BOND_ATOM2_] == wa3 + 1){ /* _BOND_ATOM1_ wa2Ǥʤ() */
        if (wa41 < 0) wa41 = subcomp->Wbonds[j][_BOND_ATOM1_] - 1;
        else          wa42 = subcomp->Wbonds[j][_BOND_ATOM1_] - 1;
      }
    }

    if (wa11 < 0 || wa41 < 0) return _NO_;
    if (wa12 < 0){ 
      wa1 = wa11;
    } else {
      if (wa11 < wa12) wa1 = wa11;
      else             wa1 = wa12;
    }
    if (wa42 < 0){ 
      wa4 = wa41;
    } else {
      if (wa41 < wa42) wa4 = wa41;
      else             wa4 = wa42;
    }

//printf("P(%d) %d - %d = %d - %d : %d\n", i, pa1, pa2, pa3, pa4, subcomp->Pbonds[i][_BOND_GEOMETRY_]);
//printf("W(%d) %d - %d = %d - %d : %d\n", wbond, wa1, wa2, wa3, wa4, subcomp->Wbonds[wbond][_BOND_GEOMETRY_]);
    /* pa1wa1ޥåƤ뤫 */
    /* pa4wa4ޥåƤ뤫 */
    /* ޥåƤʤС줾cis/transɾȿž */
    side2 = side3 = 0;
    if (is_on(mat[pa1], wa1) == 0) side2 = 1;
    if (is_on(mat[pa4], wa4) == 0) side3 = 1;

    if (side2 + side3 == 1){ /* ȿž */
      if (subcomp->Pbonds[i][_BOND_GEOMETRY_] == subcomp->Wbonds[wbond][_BOND_GEOMETRY_]) return _NO_;
    } else {                 /* Τޤ */
      if (subcomp->Pbonds[i][_BOND_GEOMETRY_] != subcomp->Wbonds[wbond][_BOND_GEOMETRY_]) return _NO_;
    }
  }

  return _YES_;
}

