#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "subcomp.h"

/* 濴ҤƸҤء4ĤΥ٥ȥ뤫žθ()׻ */
/* ͱ黻饤֥ѤʤΤǡγѤ׻ڤˡ */
double calcRotation(double v[][3]){
  double mat[3][3];

  mat[0][0] = v[1][0] - v[0][0];
  mat[0][1] = v[1][1] - v[0][1];
  mat[0][2] = v[1][2] - v[0][2];
  mat[1][0] = v[2][0] - v[0][0];
  mat[1][1] = v[2][1] - v[0][1];
  mat[1][2] = v[2][2] - v[0][2];
  mat[2][0] = v[3][0] - v[0][0];
  mat[2][1] = v[3][1] - v[0][1];
  mat[2][2] = v[3][2] - v[0][2];

  return mat[0][0] * (mat[1][1] * mat[2][2] - mat[1][2] * mat[2][1]) +
         mat[0][1] * (mat[1][2] * mat[2][0] - mat[1][0] * mat[2][2]) +
         mat[0][2] * (mat[1][0] * mat[2][1] - mat[1][1] * mat[2][0]);
}

/* γѤ */
double torsionAngle(double *a, double *b, double *c, double *d){
  int i;
  double torsion;
  double b1[3], b2[3], b3[3];
  double c1[3], c2[3], c3[3];

  for (i = 0; i < 3; i++){
    b1[i] = a[i] - b[i];
    b2[i] = b[i] - c[i];
    b3[i] = c[i] - d[i];
  }

  cross(b1, b2, c1);
  cross(b2, b3, c2);
  cross(c1, c2, c3);

  torsion = angle(c1, c2);
  if (innerProduct(b2, c3) > 0.0) torsion = -torsion;

  return torsion;
}

void cross(double *v1, double *v2, double *a){
  a[0] =   v1[1] * v2[2] - v1[2] * v2[1];
  a[1] = - v1[0] * v2[2] + v1[2] * v2[0];
  a[2] =   v1[0] * v2[1] - v1[1] * v2[0];
  return;
}

/* ١饸֤ */
double angle(double *v1, double *v2){ 
  double dp;
  double v1len, v2len;

  v1len = sqrt(v1[0] * v1[0] + v1[1] * v1[1] + v1[2] * v1[2]);
  v2len = sqrt(v2[0] * v2[0] + v2[1] * v2[1] + v2[2] * v2[2]);
  if (v1len < _NEARLY_ZERO_ || v2len < _NEARLY_ZERO_) return 999.0;

  dp = innerProduct(v1, v2) / (v1len * v2len);
  return acos(dp);
}

/*  */
double innerProduct(double *v1, double *v2){
  return v1[0] * v2[0] + v1[1] * v2[1] + v1[2] * v2[2];
}
