/*
  matrix.c
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "subcomp.h"


/* ޥȥåΥǡ򥳥ԡԡΰϳݺѤߤǤ뤳 */
int copyMATRIX(unsigned int **src, unsigned int **dist, int row, int length){
  int i, j;

  for (i = 0; i < row; i++){
    for (j = 0; j < length; j++){
      dist[i][j] = src[i][j];
    }
  }

  return _YES_;
}

/* ޥȥåƹ */
int resetMATRIX(unsigned int ***mm, int row, int length){
  int i;

  if (*mm == NULL){
    *mm = mallocArray_uint2(row, length);
    if (*mm == NULL) return _NO_;
  } else {
    for (i = 0; i < row; i++){
      if ((*mm)[i] != NULL){
        free((*mm)[i]);  /* ʤʤϤ */
      }

      (*mm)[i] = (unsigned int*)malloc(sizeof(unsigned int) * length);
      if ((*mm)[i] == NULL) return _NO_;
      memset((*mm)[i], 0, sizeof(unsigned int) * length);
    }
  }

  return _YES_;
}

/* ޥȥåƹ */
int resetMATRIXARRAY(unsigned int ****mm, int depth, int row, int length){
  int i, j;

  if ((*mm) == NULL){
    *mm = mallocArray_uint3(depth, row, length);
    if (*mm == NULL) return _NO_;
  } else {
    for (i = 0; i < depth; i++){
      if ((*mm)[i] == NULL){
        (*mm)[i] = mallocArray_uint2(row, length);
        if ((*mm)[i] == NULL) return _NO_;
      } else {
        for (j = 0; j < row; j++){
          if ((*mm)[i][j] != NULL){
            free((*mm)[i][j]);  /* ʤʤϤ */
          }

          (*mm)[i][j] = (unsigned int*)malloc(sizeof(unsigned int) * length);
          if ((*mm)[i][j] == NULL) return _NO_;
          memset((*mm)[i][j], 0, sizeof(unsigned int) * length);
        }
      }
    }
  }

  return _YES_;
}


/*************************************
 
*************************************/
char **mallocArray_char2(int row, int col){

  char **pp = NULL;
  int i = 0;

  /* ϥå */
  if (row < 1 || col < 1) {
    return pp;
  }

  /* char* δΥΰ */
  pp = (char**)malloc(sizeof(char*) * row);
  if (pp != NULL) {
    /* ΰ */
    memset(pp, 0, sizeof(char*) * row);
  } else {
    /* NULL֤ */
    return pp;
  }

  for (i = 0; i < row; i++) {
    /* cjar ΣΥΰ */
    char *p = (char*)malloc(sizeof(char) * col);

    /* char ΣΥΰݤɤ */
    if (p != NULL) {
      /* ΰ */
      memset(p, 0, sizeof(char) * col);
      pp[i] = p;
    } else {
      int j = 0;

      /* ԤޤǤ˳ݤΰ */
      for (j = 0; j < i; j++){
        free(pp[j]);
        pp[j] = NULL;
      }
      free(pp);
      pp = NULL;

      /* NULL֤ */
      return pp;
    }
  }

  return pp;
}

int **mallocArray_int2(int row, int length){

  int **pp = NULL;
  int i = 0;

  /* ϥå */
  if (row < 1 || length < 1) {
    return pp;
  }

  /* int* δΥΰ */
  pp = (int **)malloc(sizeof(int *) * row);
  if (pp != NULL) {
    /* ΰ */
    memset(pp, 0, sizeof(int*) * row);
  } else {
    /* NULL֤ */
    return pp;
  }

  for (i = 0; i < row; i++) {
    /* int ΣΥΰ */
    int *p = (int *)malloc(sizeof(int) * length);

    /* unsigned int ΣΥΰݤɤ */
    if (p != NULL) {
      /* ΰ */
      memset(p, 0, sizeof(int) * length);
      pp[i] = p;
    } else {
      int j = 0;

      /* ԤޤǤ˳ݤΰ */
      for (j = 0; j < i; j++){
        free(pp[j]);
        pp[j] = NULL;
      }
      free(pp);
      pp = NULL;

      /* NULL֤ */
      return pp;
    }
  }

  return pp;
}

unsigned int **mallocArray_uint2(int row, int length){

  unsigned int **pp = NULL;
  int i = 0;

  /* ϥå */
  if (row < 1 || length < 1) {
    return pp;
  }

  /* unsigned int* δΥΰ */
  pp = (unsigned int**)malloc(sizeof(unsigned int*) * row);
  if (pp != NULL) {
    /* ΰ */
    memset(pp, 0, sizeof(unsigned int*) * row);
  } else {
    /* NULL֤ */
    return pp;
  }

  for (i = 0; i < row; i++) {
    /* unsigned int ΣΥΰ */
    unsigned int *p = (unsigned int*)malloc(sizeof(unsigned int) * length);

    /* unsigned int ΣΥΰݤɤ */
    if (p != NULL) {
      /* ΰ */
      memset(p, 0, sizeof(unsigned int) * length);
      pp[i] = p;
    } else {
      int j = 0;

      /* ԤޤǤ˳ݤΰ */
      for (j = 0; j < i; j++){
        free(pp[j]);
        pp[j] = NULL;
      }
      free(pp);
      pp = NULL;

      /* NULL֤ */
      return pp;
    }
  }

  return pp;
}

unsigned int ***mallocArray_uint3(int depth, int row, int length){

  unsigned int ***pp = NULL;
  int i = 0;

  /* ϥå */
  if (depth < 1 || row < 1 || length < 1) {
    return pp;
  }

  /* unsigned int** δΥΰ */
  pp = (unsigned int***)malloc(sizeof(unsigned int**) * depth);
  if (pp != NULL) {
    /* ΰ */
    memset(pp, 0, sizeof(unsigned int**) * depth);
  } else {
    /* NULL֤ */
    return pp;
  }

  for (i = 0; i < depth; i++) {
    /* unsigned int ΣΥΰ */
    unsigned int **p = mallocArray_uint2(row, length);

    /* unsigned int ΣΥΰݤɤ */
    if (p != NULL) {
      pp[i] = p;
    } else {
      int j = 0;

      /* ԤޤǤ˳ݤΰ */
      for (j = 0; j < i; j++){
        freeArray_uint2(&(pp[j]), row);
        pp[j] = NULL;
      }
      free(pp);
      pp = NULL;

      /* NULL֤ */
      return pp;
    }
  }

  return pp;
}
void freeArray_char2(char ***pp, int row){
  int i = 0;

  if ((*pp) != NULL) {
    for (i = 0; i < row; i++) {
      if ((*pp)[i] != NULL) {
        free((*pp)[i]);
        (*pp)[i] = NULL;
      }
    }
    free(*pp);
    (*pp) = NULL;
  }

  return;
}

void freeArray_int2(int ***pp, int row){
  int i = 0;

  if ((*pp) != NULL) {
    for (i = 0; i < row; i++) {
      if ((*pp)[i] != NULL) {
        free((*pp)[i]);
        (*pp)[i] = NULL;
      }
    }
    free(*pp);
    (*pp) = NULL;
  }

  return;
}

void freeArray_uint2(unsigned int ***pp, int row){
  int i = 0;

  if ((*pp) != NULL) {
    for (i = 0; i < row; i++) {
      if ((*pp)[i] != NULL) {
        free((*pp)[i]);
        (*pp)[i] = NULL;
      }
    }
    free(*pp);
    (*pp) = NULL;
  }

  return;
}

void freeArray_uint3(unsigned int ****pp, int depth, int row){
  int i = 0;

  if ((*pp) != NULL) {
    for (i = 0; i < depth; i++) {
      if ((*pp)[i] != NULL) {
        freeArray_uint2(&((*pp)[i]), row);
      }
    }
    free(*pp);
    (*pp) = NULL;
  }

  return;
}

char* StrAllocCopy(char** dest, char* src){
  if (*dest != NULL){
    free(*dest);
  }
  if (src == NULL){
    *dest = NULL;
  } else {
    *dest = (char *) malloc (strlen(src) + 1);
    if (*dest == NULL) {
      *dest = NULL;
    } else {
      strcpy (*dest, src);
    }
  }
  return *dest;
}

