/*
  MOL񼰤ɤ߹
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "subcomp.h"

void substr(char *, char *, int, int);
void getChargeValue(int, int *);
void setChargeValue(int, int *);
int findRingSimple(CPDMOL *);
int findRingSimple_r(CPDMOL *, int, int, unsigned int *);
int findRing(CPDMOL *, RING_LIST *, int, int, int, int *, int *);

RING *create_RING(int, int);
void free_RING(RING **);
void freeMember_RING(RING *);
int setlist_RING(RING *, RING_LIST *);

/*
    :  CPDMOL ɤ߹
             NULL   Ǹޤã⤷MOLǡΥǡϻȤʤ

    : ΤȤMOLSDб
*/
CPDMOL *read_CPDMOL_MDL(FILE *fp){

  CPDMOL *ret;
  char buff[BUFSIZ]; /* Хåե */
  char cstr[BUFSIZ]; /* ԡХåե */
  int i, j;
  int idx1;
  int idx2;
  int num, no, val;
  int line_no = 0;
  int prop_flg = _NO_;
  ATOM *atom;
  BOND *bond;

  ret = (CPDMOL *)malloc(sizeof(CPDMOL));
  memset(ret, 0, sizeof(CPDMOL));
  if (ret == NULL) return ret;

  /* "M  END"ޤ("M  END"̵ȥ顼) */
  for (;;){
    if (fgets(buff, sizeof(buff), fp) == NULL){
      free(ret);
      return NULL;
    }
    line_no++;

    /* ¤󤬽餺Ƭ 'M' ޤ '$' äϥ顼 */
    if (prop_flg == _NO_ &&
        (buff[0] == 'M' || buff[0] == '$')){
      free(ret);
      return NULL;
    }

    /* HEADER BLOCKɤФ (13) */
    if (line_no < 4){
      continue;
    } else
    /* COUNT LINEɤ߽Ф (4) */
    if (line_no == 4){
      if (strlen(buff) < 6){ /* ҿʤХ顼 */
        free(ret);
        return NULL;
      }
      substr(cstr, buff, 1, 3);
      sscanf(cstr, "%d", &(ret->atomnum));
      substr(cstr, buff, 4, 3);
      sscanf(cstr, "%d", &(ret->bondnum));
      if (ret->atomnum < 1 || ret->bondnum < 0){
        free(ret);
        return NULL;
      }

      ret->atom = (ATOM *)malloc(sizeof(ATOM) * ret->atomnum);
      memset(ret->atom, 0, sizeof(ATOM) * ret->atomnum);
      if (ret->bondnum > 0){
        ret->bond = (BOND *)malloc(sizeof(BOND) * ret->bondnum);
        memset(ret->bond, 0, sizeof(BOND) * ret->bondnum);
      }
      if (ret->atom == NULL ||
          (ret->bondnum > 0 && ret->bond == NULL)){
        clear_CPDMOL(ret);
        free(ret);
        return NULL;
      }
    } else
    /* ATOM BLOCKɤ߽Ф */
    if (line_no <= ret->atomnum + 4){
      if (strlen(buff) < 34){ /* ǵޤǤξ󤬤ʤХ顼 */
        clear_CPDMOL(ret);
        free(ret);
        return NULL;
      }
      atom = &(ret->atom[line_no - 5]);
      substr(cstr, buff,  1, 10);
      sscanf(cstr, "%lf", &(atom->x));
      substr(cstr, buff, 11, 10);
      sscanf(cstr, "%lf", &(atom->y));
      substr(cstr, buff, 21, 10);
      sscanf(cstr, "%lf", &(atom->z));
      substr(cstr, buff, 32, 3);
      sscanf(cstr, "%s", atom->aid);
      atom->atomno = getAtomNo(atom->aid);

      if (strlen(buff) >= 40){ /* Ų٤ηޤǤʤ */
        substr(cstr, buff, 37, 3);
        sscanf(cstr, "%d", &val);
        getChargeValue(val, &(atom->charge));
      }
    } else
    /* BOND BLOCKɤ߽Ф */
    if (line_no <= ret->atomnum + ret->bondnum + 4){
      if (strlen(buff) < 12){ /* ΩΤޤǤξ󤬤ʤХ顼 */
        clear_CPDMOL(ret);
        free(ret);
        return NULL;
      }
      bond = &(ret->bond[line_no - ret->atomnum - 5]);
      substr(cstr, buff,  1, 3);
      sscanf(cstr, "%d", &(bond->a1));
      substr(cstr, buff,  4, 3);
      sscanf(cstr, "%d", &(bond->a2));
      substr(cstr, buff,  7, 3);
      sscanf(cstr, "%d", &(bond->order));
      substr(cstr, buff, 10, 3);
      sscanf(cstr, "%d", &(bond->stereo));

      /* 礷Ƥ븶Ҥֹ椬ϰϳʤ饨顼 */
      if (bond->a1 < 1 || bond->a1 > ret->atomnum ||
          bond->a2 < 1 || bond->a2 > ret->atomnum){
        clear_CPDMOL(ret);
        free(ret);
        return NULL;
      }

      /* ƸҤη򥫥ȥå */
      ret->atom[bond->a1 - 1].bondnum++;
      ret->atom[bond->a2 - 1].bondnum++;
    } else
    /* PROPERTY BLOCKɤ߽Ф */
    if (prop_flg == _YES_){
      if (strncmp(buff, "M  END", 6) == 0) break;

      if (strncmp(buff, "M  CHG", 6) == 0){   /* Ų */
        if (strlen(buff) < 9) continue;
        substr(cstr, buff, 7, 3);
        sscanf(cstr, "%d", &num);
        if (num > 8) num = 8;
        if (strlen(buff) < num * 8 + 9) num = (strlen(buff) - 9) / 8;

        for(i = 0; i < num; i++){
          substr(cstr, buff, 10 + i * 8, 4);
          sscanf(cstr, "%d", &no);
          substr(cstr, buff, 14 + i * 8, 4);
          sscanf(cstr, "%d", &val);
          if (no > 0 && no <= ret->atomnum)
            ret->atom[no - 1].charge = val;
        }
      }
    } else {
      /* ˤ뤳ȤϤʤ */
      clear_CPDMOL(ret);
      free(ret);
      return NULL;
    }

    if (line_no == ret->atomnum + ret->bondnum + 4){
      /* ʸιԤ"M"ǻϤޤ */
      prop_flg = _YES_;
    }
  }

  /* ATOM¤ΤˡҤ˴ϢƤʬΰ */
  for (i = 0; i < ret->atomnum; i++){
    ret->atom[i].bond = (int *)malloc(sizeof(int) * ret->atom[i].bondnum);
    if (ret->atom[i].bond == NULL){
      clear_CPDMOL(ret);
      free(ret);
      return NULL;
    }
    memset(ret->atom[i].bond, -1, sizeof(int) * ret->atom[i].bondnum);
  }

  /* ʬҥǡηֹ(ƬINDEX 0) */
  for (i = 0; i < ret->bondnum; i++){
    idx1 = ret->bond[i].a1 - 1;
    idx2 = ret->bond[i].a2 - 1;

    for (j = 0; j < ret->atom[idx1].bondnum; j++){
      if (ret->atom[idx1].bond[j] == -1){
         ret->atom[idx1].bond[j] = i;
         break;
      }
    }
    for (j = 0; j < ret->atom[idx2].bondnum; j++){
      if (ret->atom[idx2].bond[j] == -1){
         ret->atom[idx2].bond[j] = i;
         break;
      }
    }
  }

  /* "$$$$"ޤɤ߹ */
  while(fgets(buff, sizeof(buff), fp) != NULL){
    if (strncmp(buff, "$$$$", 4) == 0) break;
  }

  return ret;
}

/*
 cstr  ԡʸ
 sstr  ԡʸ
 s     ڤФϰ(1)
 n     ڤФʬʸ

 ϰϤΥåϤƾά
*/
void substr(char *cstr, char *sstr, int s, int n){
  int c = 0;
  int p = 0;

  cstr[0] = '\0';

  /* ʸڤФ */
  for (c = s - 1, p = 0; c < s+n-1; c++, p++)
    cstr[p] = sstr[c];

  cstr[p] = '\0';
}

/*
 MDL(MOL)Ų(charge)ͤǡͤѴ
 0  7 ʳŲ٥ʥȤ
*/
void getChargeValue(int charge, int *value){
  /* MDL(MOL)Ų(charge)ͤǡͤѴ */
  switch (charge) {
  case 1:
    (*value) = 3;
    break;
  case 2:
    (*value) = 2;
    break;
  case 3:
    (*value) = 1;
    break;
  case 5:
    (*value) = -1;
    break;
  case 6:
    (*value) = -2;
    break;
  case 7:
    (*value) = -3;
    break;
  case 0:
  case 4:
  default:
    /* ƤϤޤʤŲ٥ʥ */
    (*value) = 0; /* 04⡢0Ȥư */
    break;
  }
}

/*
 Ų(charge)ΥǡͤMDL(MOL)νͤѴ
 ǡͤ0(ϻ04)ϡϻ0
*/
void setChargeValue(int charge, int *value){
  /* Ų(charge)ΥǡͤMDL(MOL)νͤѴ */
  switch (charge) {
  case -3:
    (*value) = 7;
    break;
  case -2:
    (*value) = 6;
    break;
  case -1:
    (*value) = 5;
    break;
  case 1:
    (*value) = 3;
    break;
  case 2:
    (*value) = 2;
    break;
  case 3:
    (*value) = 1;
    break;
  case 0:
  default:
    /* ƤϤޤʤ0 */
    (*value) = 0; /* Ϥ4ξ⡢0Ȥƽ */
    break;
  }
}

int searchRing(CPDMOL *cpdmol, RING_LIST *ringlist){
  int i = 0;
  int j = 0;
  int *workflag = NULL;
  int *bondflag = NULL;

  /* 礬ʤʬҤ˴ؤƤϡνϹԤʤ */
  if (cpdmol->bondnum == 0) {
    return _NO_;
  }

  /* õʰ */
  /* Ĥԥåå */
  if (findRingSimple(cpdmol) == _NO_) return _NO_;

  /* åѥ(ʬ) (=0) */
  workflag = (int *)malloc(sizeof(int) * cpdmol->bondnum);
  if (workflag == NULL) return _NO_;
  memset(workflag, 0, sizeof(int) * cpdmol->bondnum);

  /* åоݥե饰(ʬ) (=1) =1:åоݡ=0:о */
  bondflag = (int *)malloc(sizeof(int) * cpdmol->bondnum);
  if (bondflag == NULL){
    free(workflag);
    return _NO_;
  }
  for(i = 0; i < cpdmol->bondnum; i++){
    /* ʰץåη̤ͤˤ */
    /* õκݡηé */
    bondflag[i] = cpdmol->bond[i].ring;
  }

  /* ǥ롼 */
  for(i = 0; i < cpdmol->bondnum; i++){
    if (bondflag[i] == 0) continue;

    /* åѥ(ʬ)(=0) */
    for(j = 0; j < cpdmol->bondnum; j++) workflag[j] = 0;

    /* ηåѥ1 */
    workflag[i] = 1;

    /* õ */
    if (findRing(cpdmol,
                 ringlist,
                 cpdmol->bond[i].a1,
                 cpdmol->bond[i].a2,
                 2,
                 bondflag,
                 workflag) == _NO_) {
      free(workflag);
      free(bondflag);
      return _NO_;
    }

    /* ηΥåоݥե饰0(ʣʤ褦) */
    bondflag[i] = 0;
  }

  free(workflag);
  free(bondflag);

  return _YES_;
}

/* õʰ */
int findRingSimple(CPDMOL *cpdmol){
  int i;
  int ret = _NO_;
  int           blength;
  unsigned int *bondflag;

  blength = (cpdmol->bondnum + _BIT_LENGTH_ - 1) / _BIT_LENGTH_;
  bondflag = (unsigned int *)malloc(sizeof(unsigned int) * blength);
  if (bondflag == NULL) return _NO_;

  for (i = 0; i < cpdmol->bondnum; i++){
    memset(bondflag,   0, sizeof(unsigned int) * blength);
    on_bit(bondflag, i);
    findRingSimple_r(cpdmol, cpdmol->bond[i].a1, cpdmol->bond[i].a2, bondflag);
  }

  for (i = 0; i < cpdmol->bondnum; i++){
    if (cpdmol->bond[i].ring == _YES_){
      ret = _YES_;
      break;
    }
  }

  free(bondflag);
  return ret;
}

/* õʰ(Ƶ) */
/* ȤʤäФƴĤ1ĤǤ⸫դСδĤηOK */
int findRingSimple_r(CPDMOL *cpdmol, int start, int now, unsigned int *bondflag){
  int i, j;
  int next = -1;

  for (i = 0; i < cpdmol->bondnum; i++){
    if (is_on(bondflag, i) != 0) continue;
    if ((next = pairAtom(cpdmol, i, now)) > 0){
      on_bit(bondflag, i);
      if (pairAtom(cpdmol, i, start) > 0){
        /* ĤĤ */
        for (j = 0; j < cpdmol->bondnum; j++){
          if (is_on(bondflag, j) != 0){
            cpdmol->bond[j].ring = _YES_;
            cpdmol->atom[cpdmol->bond[j].a1 - 1].ring = _YES_;
            cpdmol->atom[cpdmol->bond[j].a2 - 1].ring = _YES_;
          }
        }
        return _YES_;
      } else {
        /* õ */
        if (findRingSimple_r(cpdmol, start, next, bondflag) == _YES_) return _YES_;
      }
      off_bit(bondflag, i);
    }
  }

  return _NO_;
}

/* õ */
int findRing(CPDMOL *cpdmol, RING_LIST *ringlist, int start_atom, int now_atom, int generation, int *pbondflag, int *pworkflag){
  int i = 0;
  int j = 0;
  int pair_atom;
  RING *wring = NULL;

  for(i = 0; i < cpdmol->bondnum; i++){
    if (pbondflag[i] == 0) continue;
    if (pworkflag[i] != 0) continue;

    /* ΰünow_atom */
    if (cpdmol->bond[i].a1 == now_atom || cpdmol->bond[i].a2 == now_atom){
      pworkflag[i] = generation;

      if (cpdmol->bond[i].a1 == start_atom || cpdmol->bond[i].a2 == start_atom){
        /* η礬start_atomȤηǤ */
        /* workflag0Ǥʤ򽸤Ring */

        /* Ĥΰ */
        wring = create_RING(cpdmol->atomnum, cpdmol->bondnum);
        if (wring == NULL) return _NO_;

        for(j = 0; j < cpdmol->bondnum; j++){
          if (pworkflag[j] != 0){
            on_bit(wring->bond, j);
            on_bit(wring->atom, cpdmol->bond[j].a1 - 1);
            on_bit(wring->atom, cpdmol->bond[j].a2 - 1);
            wring->num++;
          }
        }

        /* δľɲ */
        setlist_RING(wring, ringlist);
      } else {
        if (generation < maximum_ringstep){
          /* η礬start_atomȤηǤʤ */
          pair_atom = pairAtom(cpdmol, i, now_atom);
          if (findRing(cpdmol,
                       ringlist,
                       start_atom,
                       pair_atom,
                       generation + 1,
                       pbondflag,
                       pworkflag) == _NO_) return _NO_;
        }
      }
      pworkflag[i] = 0;
    }
  }
  return _YES_;
}

/* ˧ĥå */
/* KCFνѴǻѤƤHuckel§(ȽϸҤФƤΤ) */
/* θ塢˧ĥå */
/* ĤιҤ˧ĸҤʤ顢˧ķȤ */
int arom_checkMOL(CPDMOL *cpdmol, RING_LIST *ringlist){
  int i, j;
  int count;
  int pai_pair;
  int sp2;
  int metal;
  RING *ring;
  ATOM *atom;
  BOND *bond;

  ring = ringlist->first;
  while(ring != NULL){
    metal = _NO_;
    sp2 = _YES_;
    pai_pair = 0;
    for(i = 0; i < cpdmol->atomnum; i++){
      if (is_on(ring->atom, i) != 0){
        atom = &(cpdmol->atom[i]);
        if (atom->atomno ==  6){ /* ú */
          sp2 = _NO_;
          for (j = 0; j < atom->bondnum; j++){
            if (cpdmol->bond[atom->bond[j]].order == 2){
              sp2 = _YES_;
              break;
            }
          }
          if (sp2 == _NO_) break;
        } else
        if (atom->atomno ==  7 ||  /*  */
            atom->atomno ==  8 ||  /*  */
            atom->atomno == 15 ||  /*  */
            atom->atomno == 16 ||  /* β */
            atom->atomno == 34){   /*  */
          count = 0;
          for (j = 0; j < atom->bondnum; j++){
            if (cpdmol->bond[atom->bond[j]].order == 1){
              count++;
            } else {
              count = 0;
              break;
            }
          }
          if (count > 1) pai_pair++;
        } else {
          metal = _YES_; /* ʳ°Ȥߤʤ */
          break;
        }
      }
    }

    if (metal == _NO_ && sp2 == _YES_){
      /* ŷ(ĤǤϤʤ̴ʬθ)ο */
      for(i = 0; i < cpdmol->bondnum; i++){
        bond = &(cpdmol->bond[i]);
        if (is_on(ring->atom, bond->a1 - 1) != 0 &&
            is_on(ring->atom, bond->a2 - 1) != 0){
          if (bond->order == 2) pai_pair++;
        }
      }

      if (pai_pair * 2 >= ring->num && pai_pair % 2 == 1){
        /* ˧ĤȤߤʤ */
        ring->arom = _YES_;
        /* Ҥ˧ľ */
        for (i = 0; i < cpdmol->atomnum; i++){
          if (is_on(ring->atom, i) != 0) cpdmol->atom[i].arom = _YES_;
        }
      }
    }
    ring = ring->next;
  }

  /* ˧ľ */
  ring = ringlist->first;
  while(ring != NULL){
    count = 0;
    for (i = 0; i < cpdmol->atomnum; i++){
      if (is_on(ring->atom, i) != 0 &&
          cpdmol->atom[i].arom == _YES_) count++;
    }
    if (count == ring->num){
      for (i = 0; i < cpdmol->bondnum; i++){
        if (is_on(ring->bond, i) != 0) cpdmol->bond[i].arom = _YES_;
      }
    }
    ring = ring->next;
  }

  return _YES_;
}

/* ¤ΤΥΰݤ */
RING *create_RING(int atomnum, int bondnum){
  RING *p;
  int alength = (atomnum + _BIT_LENGTH_ - 1) / _BIT_LENGTH_;
  int blength = (bondnum + _BIT_LENGTH_ - 1) / _BIT_LENGTH_;

  /* ¤ΤΥΰ */
  p = (RING *)malloc(sizeof(RING));
  if (p != NULL){
    /* ¤Τ */
    memset(p, 0, sizeof(RING));
    p->atom = (unsigned int *)malloc(sizeof(unsigned int) * alength);
    p->bond = (unsigned int *)malloc(sizeof(unsigned int) * blength);
    if (p->atom == NULL || p->bond == NULL){
      free_RING(&p);
    } else {
      memset(p->atom, 0, sizeof(unsigned int) * alength);
      memset(p->bond, 0, sizeof(unsigned int) * blength);
    }
  }
  return p;
}

/* ¤ΤΥΰ */
void free_RING(RING **p){
  if ((*p) != NULL) {
    /* ФưŪΰ˲ */
    freeMember_RING(*p);
    /* ¤ΤΥΰ */
    free(*p);
    (*p) = NULL;
  }
  return;
}

/* ФưŪΰ */
void freeMember_RING(RING *p){
  if (p != NULL) {
    if (p->atom != NULL){
      free(p->atom);
      p->atom = NULL;
    }
    if (p->bond != NULL){
      free(p->bond);
      p->bond = NULL;
    }
    p->num = 0;
  }

 return;
}

/* ꥹ()ɲä */
int setlist_RING(RING *p, RING_LIST *plist){

  /* ϥå */
  if (p == NULL) return _NO_;
 
  /* ݥ󥿤ν */
  p->prev = plist->last; /* ߤκǸʬΥݥ󥿤Ȥ */
  p->next = NULL;        /* ȤꤢƬNULLȤ */

  /* ʤ */
  if (plist->last != NULL) {
    plist->last->next = p; /* μϼʬȤ */
  }

  /* Ƭ򤬤ʤ */
  if (plist->first == NULL) {
    plist->first = p; /* ʬƬȤ */
  }

  /* ι¤ΤΤᡢʬǸȤ */
  plist->last = p;

  /* ǡΥ󥯥 */
  plist->num++;

  return _YES_;
}

/* ꥹȤꤷΰ() */
void free_RINGLIST(RING_LIST *plist){
  RING *p;
  RING *next;

  /* ƬΥݥ󥿤 */
  p = plist->first;
  if (p == NULL) return;

  /* Ƭ顢ݥ󥿤¤ */
  while(p != NULL) {
    next = p->next;
    free_RING(&p);
    p = next;
  }

  plist->first = NULL;
  plist->last  = NULL;
  plist->num   = 0;

  return;
}

